=== PyCore/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainPyCore
############################################################################

# NOTE: The module is directly dependent on Python and Numpy C-API
if(NOT BORNAGAIN_PYTHON)
    message(FATAL_ERROR "PyCore module requested although BORNAGAIN_PYTHON=false")
endif()

set(component PyCore)
set(lib BornAgain${component})

# --- source and include files ---
# Python-dependent source files
file(GLOB_RECURSE source_files */*.cpp)
file(GLOB_RECURSE include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)
list(APPEND include_files "${AUTO_WRAP_DIR}/swig_runtime.h")

# --- make the library ---

add_library(${lib} SHARED)
if(CONFIGURE_BINDINGS)
    add_dependencies(${lib} swig_runtime)
endif(CONFIGURE_BINDINGS)
MakeLib(${lib} "" "${source_files}" "${include_files}")

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    ${Python3_LIBRARIES}
)
target_include_directories(${lib}
    PRIVATE
    ${CMAKE_SOURCE_DIR}
    ${LibHeinz_INCLUDE_DIR}
    ${Python3_INCLUDE_DIRS}
    ${Python3_NumPy_INCLUDE_DIRS}
)
