=== debian/changelog ===
bornagain (22~git20240726093306.cb41cc4+ds3-2) unstable; urgency=medium

  * Fix autopkgtest so that it actually fails on error.
  * Bug fix: "error while loading shared libraries: _libBornAgainGUI.so:
    cannot open shared object file: No such file or directory", thanks to
    Picca Frédéric-Emmanuel (Closes: #1078439).
  * This also fixes: "please add autopkgtests (to add coverage for
    python3-matplotlib)", thanks to Sandro Tosi (Closes: #1036492).

 -- Roland Mas <lolando@debian.org>  Tue, 13 Aug 2024 23:03:24 +0200

bornagain (22~git20240726093306.cb41cc4+ds3-1) unstable; urgency=medium

  * New upstream release. This fixes "ftbfs with GCC-14", thanks to
    Matthias Klose (Closes: #1074853).

 -- Roland Mas <lolando@debian.org>  Fri, 26 Jul 2024 16:23:15 +0200

bornagain (22~git20240516130453.4d28e9f+ds3-1) experimental; urgency=medium

  * New upstream snapshot.

 -- Roland Mas <lolando@debian.org>  Wed, 22 May 2024 16:50:55 +0200

bornagain (22~git20240514151320.6d9f79d+ds3-3) experimental; urgency=medium

  * Fix --build=all,source builds.

 -- Roland Mas <lolando@debian.org>  Wed, 22 May 2024 16:48:41 +0200

rnagain (22~git20240514151320.6d9f79d+ds3-2) experimental; urgency=medium

  * Fix another instance of an arch-specific path in debian/rules.

 -- Roland Mas <lolando@debian.org>  Wed, 15 May 2024 10:55:50 +0200

bornagain (22~git20240514151320.6d9f79d+ds3-1) experimental; urgency=medium

  * New upstream snapshot.

 -- Roland Mas <lolando@debian.org>  Wed, 15 May 2024 01:08:16 +0200

bornagain (22~git20240514090930.55112b1+ds3-1) experimental; urgency=medium

  * New upstream snapshot.

 -- Roland Mas <lolando@debian.org>  Tue, 14 May 2024 11:17:05 +0200

bornagain (22~git20240513132534.e278a05+ds3-2) experimental; urgency=medium

  * Fix arch-specific path in debian/rules to help with the i386/i686
    dichotomy.

 -- Roland Mas <lolando@debian.org>  Mon, 13 May 2024 23:33:55 +0200

bornagain (22~git20240513132534.e278a05+ds3-1) experimental; urgency=medium

  * New upstream snapshot.

 -- Roland Mas <lolando@debian.org>  Mon, 13 May 2024 15:53:20 +0200

bornagain (22~git20240512164208.1811a04+ds3-3) experimental; urgency=medium

  * New upstream snapshot.
  * Enable -DBA_3ARCH=ON as suggested by upstream.

 -- Roland Mas <lolando@debian.org>  Sun, 12 May 2024 20:02:42 +0200

bornagain (22~20240509+ds3-1) experimental; urgency=medium

  * Snapshot of upstream Git's main branch.

 -- Roland Mas <lolando@debian.org>  Thu, 09 May 2024 20:24:15 +0200

bornagain (21.2~20240509+ds3-1) experimental; urgency=medium

  * Snapshot of upstream Git's r21 branch

 -- Roland Mas <lolando@debian.org>  Thu, 09 May 2024 18:14:39 +0200

bornagain (21.1+ds3-5) unstable; urgency=medium

  * Tweak size detection of numeric types; this should fix some of the
    arch-specific FTBFSes.

 -- Roland Mas <lolando@debian.org>  Tue, 30 Apr 2024 16:41:19 +0200
